'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = fetch;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _hoistNonReactStatics = require('hoist-non-react-statics');

var _hoistNonReactStatics2 = _interopRequireDefault(_hoistNonReactStatics);

var _invariant = require('invariant');

var _invariant2 = _interopRequireDefault(_invariant);

var _storeShape = require('react-redux/lib/utils/storeShape');

var _storeShape2 = _interopRequireDefault(_storeShape);

var _reducer = require('./reducer.js');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function getDisplayName(WrappedComponent) {
  return WrappedComponent.displayName || WrappedComponent.name || 'Component';
}

function getStateDefault(store) {
  return store.getState().prefetching;
}

function fetch(namespace, action) {
  var options = arguments.length <= 2 || arguments[2] === undefined ? {} : arguments[2];
  var getState = arguments.length <= 3 || arguments[3] === undefined ? getStateDefault : arguments[3];
  var _options$withRef = options.withRef;
  var withRef = _options$withRef === undefined ? false : _options$withRef;

  function fetchData(store, params) {
    var state = getState(store)[namespace];
    var result = action(store, params, state);

    if (!state) {
      store.dispatch((0, _reducer.prefetchInit)(namespace, result));
      return result.reflect().then(function (data) {
        var act = undefined;
        var value = undefined;
        if (data.isFulfilled()) {
          act = _reducer.prefetchSuccess;
          value = data.value();
        } else {
          act = _reducer.prefetchError;
          value = data.reason();
        }

        return store.dispatch(act(namespace, value));
      });
    }

    return result;
  }

  return function wrapWithFetch(WrappedComponent) {
    var Fetch = (function (_Component) {
      _inherits(Fetch, _Component);

      function Fetch(props, context) {
        _classCallCheck(this, Fetch);

        var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(Fetch).call(this, props, context));

        _this.store = props.store || context.store;

        (0, _invariant2.default)(_this.store, 'Could not find "store" in either the context or ' + ('props of "' + _this.constructor.displayName + '". ') + 'Either wrap the root component in a <Provider>, ' + ('or explicitly pass "store" as a prop to "' + _this.constructor.displayName + '".'));
        return _this;
      }

      _createClass(Fetch, [{
        key: 'componentDidMount',
        value: function componentDidMount() {
          fetchData(this.store, this.props.params);
        }
      }, {
        key: 'getWrappedInstance',
        value: function getWrappedInstance() {
          (0, _invariant2.default)(withRef, 'To access the wrapped instance, you need to specify ' + '{ withRef: true } as the fourth argument of the connect() call.');

          return this.refs.wrappedInstance;
        }
      }, {
        key: 'render',
        value: function render() {
          var ref = withRef ? 'wrappedInstance' : null;
          return _react2.default.createElement(WrappedComponent, _extends({}, this.props, { ref: ref }));
        }
      }]);

      return Fetch;
    })(_react.Component);

    Fetch.displayName = 'Fetch(' + getDisplayName(WrappedComponent) + ')';
    Fetch.propTypes = {
      store: _storeShape2.default,
      params: _react.PropTypes.object
    };
    Fetch.contextTypes = {
      store: _storeShape2.default
    };
    Fetch.fetch = fetchData;
    Fetch.WrappedComponent = WrappedComponent;

    return (0, _hoistNonReactStatics2.default)(Fetch, WrappedComponent);
  };
}