'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = initResolver;

var _bluebird = require('bluebird');

var _bluebird2 = _interopRequireDefault(_bluebird);

var _lodash = require('lodash.forown');

var _lodash2 = _interopRequireDefault(_lodash);

var _redux = require('redux');

var _constants = require('./constants.js');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { return obj && typeof Symbol !== "undefined" && obj.constructor === Symbol ? "symbol" : typeof obj; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var FILTER_ACTIONS = [_constants.REDUX_PREFETCH_INIT, _constants.REDUX_PREFETCH_SUCCESS, _constants.REDUX_PREFETCH_ERROR];

var AsyncResolver = (function () {
  function AsyncResolver() {
    var _this = this;

    _classCallCheck(this, AsyncResolver);

    this.iterateOverComponents = function (filteredComponents, params) {
      var store = _this.store;
      var pendingActions = _this.pendingActions;

      return _bluebird2.default.map(filteredComponents, function (component) {
        return component.fetch(store, params);
      }).then(function () {
        var queue = [].concat(pendingActions);
        pendingActions.splice(0, pendingActions.length);
        return _bluebird2.default.join.apply(_bluebird2.default, _toConsumableArray(queue));
      }).reflect().then(function () {
        if (pendingActions.length > 0) {
          return _this.iterateOverComponents(filteredComponents, params);
        }
      }).then(store.getState);
    };

    this.pendingActions = [];
    this.store = null;
  }

  _createClass(AsyncResolver, [{
    key: 'resolve',
    value: function resolve(store) {
      var _this2 = this;

      this.store = store;

      return function (components, params) {
        return _bluebird2.default.filter(components, function (component) {
          return component && typeof component.fetch === 'function';
        }).then(function (filteredComponents) {
          return _this2.iterateOverComponents(filteredComponents, params);
        });
      };
    }
  }, {
    key: 'middleware',
    value: function middleware() {
      var pendingActions = this.pendingActions;

      return function (store) {
        return function (next) {
          return function (action) {
            var resultingAction = next(action);
            if (FILTER_ACTIONS.indexOf(action.type) > -1) {
              return resultingAction;
            }

            var promises = [];

            (0, _lodash2.default)(resultingAction.payload, function (prop) {
              if (prop && (typeof prop === 'undefined' ? 'undefined' : _typeof(prop)) === 'object' && typeof prop.then === 'function') {
                promises.push(prop);
              }
            });

            if (promises.length > 0) {
              pendingActions.push.apply(pendingActions, promises);
            }

            return resultingAction;
          };
        };
      };
    }
  }]);

  return AsyncResolver;
})();

function initResolver(next) {
  return function (reducer, initialState) {
    var asyncResolver = new AsyncResolver();
    var store = (0, _redux.applyMiddleware)(asyncResolver.middleware())(next)(reducer, initialState);
    store.resolve = asyncResolver.resolve(store);

    return _extends({}, store);
  };
}